#!/bin/bash

if [ "$EUID" -ne 0 ];then
  echo "Please run as root"
  exit 1
fi

NODE_PATH=$(which node)
USER_NAME=nvr-integration-tool
GROUP_NAME=nvr-integration-tool
ENV_VARIABLES_FILE=/etc/nvr-integration-tool/nvr-integration-tool.env
TOKEN_FILE=/usr/share/nvr-integration-tool/token.key

systemctl stop nvr-integration-tool

rm $TOKEN_FILE
cd /usr/share/nvr-integration-tool/
source $ENV_VARIABLES_FILE
echo " ------------------------------------------------------------------------------------------ "
echo "|                                                                                          |"
echo "|  Please open the link, which is shown below, in a browser to authenticate in the system  |"
echo "|                                                                                          |"
echo " ------------------------------------------------------------------------------------------ "
echo ""
PDK_ISSUER_URI=$PDK_ISSUER_URI PDK_CLIENT_ID=$PDK_CLIENT_ID PDK_CLIENT_SECRET=$PDK_CLIENT_SECRET $NODE_PATH src/index.js --mode=setup-print-url

chown -R $USER_NAME:$GROUP_NAME $TOKEN_FILE
chmod 660 $TOKEN_FILE

systemctl start nvr-integration-tool
