'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _throat = require('throat');

var _throat2 = _interopRequireDefault(_throat);

var _tryFn = require('./tryFn');

var _tryFn2 = _interopRequireDefault(_tryFn);

var _promised = require('./promised');

var _promised2 = _interopRequireDefault(_promised);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _promised2.default)(function parallelLimit(tasks, limit) {
    for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        args[_key - 2] = arguments[_key];
    }

    if (!limit > 0) {
        return Promise.reject(new Error('Limit must be a number greater than 0.'));
    }

    return Promise.all(tasks.map((0, _throat2.default)(limit, function (task) {
        return _tryFn2.default.apply(undefined, [task].concat(args));
    })));
});
module.exports = exports['default'];