'use strict';

const fs = require('fs');
const logger = require('../logger');

class FileAdapter {
  constructor(options) {
    this._options = options;
  }

  getToken() {
    return new Promise((resolve) => {
      fs.readFile(this._options.path, (err, data) => {
        if (err) {
          logger.error(err.message);
          resolve(null);
        } else {
          resolve(data.toString());
        }
      });
    });
  }

  setToken(token) {
    return new Promise((resolve) => {
      fs.writeFile(this._options.path, token, (err) => {
        if (err) {
          logger.error(err.message);
        }
        resolve();
      });
    });
  }
}

module.exports = FileAdapter;
