'use strict';

const nconf = require('nconf');
const _ = require('lodash');

const envList = {
  'pdkClient:clientId': 'PDK_CLIENT_ID',
  'pdkClient:clientSecret': 'PDK_CLIENT_SECRET',
  'pdkClient:issuerUri': 'PDK_ISSUER_URI',
  'pdkClient:panelId': 'PDK_PANEL_ID',
  'pdkClient:reconnectTimeoutSec': 'PDK_RECONNECT_TIMEOUT_SEC',
  'spectrum:user:name': 'SPECTRUM_USER_NAME',
  'spectrum:user:password': 'SPECTRUM_USER_PASSWORD',
  'spectrum:uri': 'SPECTRUM_URI',
  'spectrum:host': 'SPECTRUM_HOST',
  'spectrum:port': 'SPECTRUM_PORT',
  'spectrum:resource': 'SPECTRUM_RESOURCE',
  'spectrum:request:timeoutSec': 'SPECTRUM_REQUEST_TIMEOUT_SEC',
  'commandServer:port': 'COMMAND_SERVER_PORT'
};

const argvList = {
  'pdkClient:clientId': 'pdk-client-id',
  'pdkClient:clientSecret': 'pdk-client-secret',
  'pdkClient:issuerUri': 'pdk-issuer-uri',
  'pdkClient:panelId': 'pdk-panel-id',
  'pdkClient:reconnectTimeoutSec': 'pdk-reconnect-timeout-sec',
  'spectrum:user:name': 'spectrum-user-name',
  'spectrum:user:password': 'spectrum-user-password',
  'spectrum:uri': 'spectrum-uri',
  'spectrum:host': 'spectrum-host',
  'spectrum:port': 'spectrum-port',
  'spectrum:resource': 'spectrum-resource',
  'spectrum:request:timeoutSec': 'spectrum-request-timeout-sec',
  'commandServer:port': 'command-server-port'
};

function grabConfig() {
  nconf
    .argv()
    .env()
    .file({file: `${__dirname}/config.json`});

  _.forEach(envList, (value, key) => {
    if(nconf.get(value)) {
      nconf.set(key, nconf.get(value));
    }
  });

  _.forEach(argvList, (value, key) => {
    if(nconf.get(value)) {
      nconf.set(key, nconf.get(value));
    }
  });
}

grabConfig();

module.exports = {
  pdkClient: nconf.get('pdkClient'),
  spectrum: nconf.get('spectrum'),
  commandServer: nconf.get('commandServer'),
  mode: nconf.get('mode')
};