'use strict';

const path = require('path');

class InvalidTokenError extends Error {
  constructor() {
    let message = 'Failed to connect to a panel because of an invalid token. Try to get a new token by running the script ';
    // we support Linux and Windows at this moment
    if (process.platform === 'win32') {
      message += `${path.join( __dirname, '..', '..', 'get-token.bat')} as an administrator`;
    } else {
      message += '/usr/local/bin/nvr-get-token.sh';
    }
    super(message);
    Error.captureStackTrace(this, this.constructor);
    this.name = this.constructor.name
  }
}

module.exports = InvalidTokenError;