'use strict';

const winston = require('winston');

const { splat, combine, timestamp, printf, colorize } = winston.format;

// meta param is ensured by splat()
const customFormat = printf(({ timestamp, level, message, meta }) => {
  return `${timestamp} ${level}: ${message} ${meta ? JSON.stringify(meta) : ''}`;
});

module.exports = winston.createLogger({
  level: 'debug',
  format: combine(
      colorize(),
      timestamp({
        format: 'YYYY-MM-DD HH:mm:ss'
      }),
      splat(),
      customFormat
  ),
  transports: [
    new winston.transports.Console()
  ]
});